// _VF[_[̓
struct VS_INPUT
{
	float3 Position        : POSITION ;			// W( [J )
	float3 Normal          : NORMAL ;			// @( [J )
	float4 Diffuse         : COLOR0 ;			// fBt[YJ[
	float4 Specular        : COLOR1 ;			// XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;		// eNX`W
	float4 TexCoords1      : TEXCOORD1 ;		// TueNX`W
	float3 Tan             : TANGENT0 ;			// ڐ( [J )
	float3 Bin             : BINORMAL0 ;		// ]@( [J )
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float2 TexCoords0      : TEXCOORD0 ;	// eNX`W
	float3 VPosition       : TEXCOORD1 ;    // W( r[ )
	float3 VTan            : TEXCOORD2 ;    // ڐ( r[ )
	float3 VBin            : TEXCOORD3 ;    // ]@( r[ )
	float3 VNormal         : TEXCOORD4 ;    // @( r[ )
	float4 Position        : SV_POSITION ;	// W( vWFNV )
} ;


// {p[^
struct DX_D3D11_VS_CONST_BUFFER_BASE
{
	float4		AntiViewportMatrix[ 4 ] ;				// A`r[|[gs
	float4		ProjectionMatrix[ 4 ] ;					// r[@@vWFNVs
	float4		ViewMatrix[ 3 ] ;						// [h@@r[s
	float4		LocalWorldMatrix[ 3 ] ;					// [J@@[hs

	float4		ToonOutLineSize ;						// gD[̗֊s̑傫
	float		DiffuseSource ;							// fBt[YJ[( 0.0f:}eA  1.0f:_ )
	float		SpecularSource ;						// XyLJ[(   0.0f:}eA  1.0f:_ )
	float		MulSpecularColor ;						// XyLJ[lɏZl( XyLŎgp )
	float		Padding ;
} ;

// ̑̍s
struct DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX
{
	float4		ShadowMapLightViewProjectionMatrix[ 3 ][ 4 ] ;			// VhE}bvp̃Cgr[sƃCgˉesZ
	float4		TextureMatrix[ 3 ][ 2 ] ;								// eNX`Wps
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_VS_BASE				: register( b1 )
{
	DX_D3D11_VS_CONST_BUFFER_BASE				g_Base ;
} ;

// ̑̍s
cbuffer cbD3D11_CONST_BUFFER_VS_OTHERMATRIX			: register( b2 )
{
	DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX		g_OtherMatrix ;
} ;


// main֐
VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	float4 lLocalPosition ;
	float4 lWorldPosition ;
	float4 lViewPosition ;
	float3 lWorldNrm ;
	float3 lWorldTan ;
	float3 lWorldBin ;
	float3 lViewNrm ;
	float3 lViewTan ;
	float3 lViewBin ;


	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// [JW̃Zbg
	lLocalPosition.xyz = VSInput.Position ;
	lLocalPosition.w = 1.0f ;

	// [JW[hWɕϊ
	lWorldPosition.x = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 0 ] ) ;
	lWorldPosition.y = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 1 ] ) ;
	lWorldPosition.z = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 2 ] ) ;
	lWorldPosition.w = 1.0f ;

	// [hWr[Wɕϊ
	lViewPosition.x = dot( lWorldPosition, g_Base.ViewMatrix[ 0 ] ) ;
	lViewPosition.y = dot( lWorldPosition, g_Base.ViewMatrix[ 1 ] ) ;
	lViewPosition.z = dot( lWorldPosition, g_Base.ViewMatrix[ 2 ] ) ;
	lViewPosition.w = 1.0f ;

	// r[WˉeWɕϊ
	VSOutput.Position.x = dot( lViewPosition, g_Base.ProjectionMatrix[ 0 ] ) ;
	VSOutput.Position.y = dot( lViewPosition, g_Base.ProjectionMatrix[ 1 ] ) ;
	VSOutput.Position.z = dot( lViewPosition, g_Base.ProjectionMatrix[ 2 ] ) ;
	VSOutput.Position.w = dot( lViewPosition, g_Base.ProjectionMatrix[ 3 ] ) ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )




	// @r[Ԃ̊pxɕϊ =====================================================( Jn )

	// ]@AڐA@r[xNgɕϊ
	lWorldTan.x = dot( VSInput.Tan, g_Base.LocalWorldMatrix[ 0 ].xyz ) ;
	lWorldTan.y = dot( VSInput.Tan, g_Base.LocalWorldMatrix[ 1 ].xyz ) ;
	lWorldTan.z = dot( VSInput.Tan, g_Base.LocalWorldMatrix[ 2 ].xyz ) ;

	lWorldBin.x = dot( VSInput.Bin, g_Base.LocalWorldMatrix[ 0 ].xyz ) ;
	lWorldBin.y = dot( VSInput.Bin, g_Base.LocalWorldMatrix[ 1 ].xyz ) ;
	lWorldBin.z = dot( VSInput.Bin, g_Base.LocalWorldMatrix[ 2 ].xyz ) ;

	lWorldNrm.x = dot( VSInput.Normal, g_Base.LocalWorldMatrix[ 0 ].xyz ) ;
	lWorldNrm.y = dot( VSInput.Normal, g_Base.LocalWorldMatrix[ 1 ].xyz ) ;
	lWorldNrm.z = dot( VSInput.Normal, g_Base.LocalWorldMatrix[ 2 ].xyz ) ;

	lViewTan.x = dot( lWorldTan, g_Base.ViewMatrix[ 0 ].xyz ) ;
	lViewTan.y = dot( lWorldTan, g_Base.ViewMatrix[ 1 ].xyz ) ;
	lViewTan.z = dot( lWorldTan, g_Base.ViewMatrix[ 2 ].xyz ) ;

	lViewBin.x = dot( lWorldBin, g_Base.ViewMatrix[ 0 ].xyz ) ;
	lViewBin.y = dot( lWorldBin, g_Base.ViewMatrix[ 1 ].xyz ) ;
	lViewBin.z = dot( lWorldBin, g_Base.ViewMatrix[ 2 ].xyz ) ;

	lViewNrm.x = dot( lWorldNrm, g_Base.ViewMatrix[ 0 ].xyz ) ;
	lViewNrm.y = dot( lWorldNrm, g_Base.ViewMatrix[ 1 ].xyz ) ;
	lViewNrm.z = dot( lWorldNrm, g_Base.ViewMatrix[ 2 ].xyz ) ;

	// @r[Ԃ̊pxɕϊ =====================================================( I )




	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// eNX`Wϊsɂϊsʂ̃eNX`WZbg
	VSOutput.TexCoords0.x = dot( VSInput.TexCoords0, g_OtherMatrix.TextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0.y = dot( VSInput.TexCoords0, g_OtherMatrix.TextureMatrix[ 0 ][ 1 ] ) ;

	// _Wۑ
	VSOutput.VPosition = lViewPosition.xyz ;

	// ڐۑ
	VSOutput.VTan = lViewTan ;

	// ]@ۑ
	VSOutput.VBin = lViewBin ;

	// @ۑ
	VSOutput.VNormal = lViewNrm ;

	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return VSOutput ;
}

